xref: /linux/scripts/kconfig/Makefile (revision 2a61625835c7c89c5f00de458a213d59ac54db21)
1# SPDX-License-Identifier: GPL-2.0
2# ===========================================================================
3# Kernel configuration targets
4# These targets are used from top-level makefile
5
6PHONY += xconfig gconfig menuconfig config syncconfig update-po-config \
7	localmodconfig localyesconfig
8
9ifdef KBUILD_KCONFIG
10Kconfig := $(KBUILD_KCONFIG)
11else
12Kconfig := Kconfig
13endif
14
15ifeq ($(quiet),silent_)
16silent := -s
17endif
18
19# We need this, in case the user has it in its environment
20unexport CONFIG_
21
22xconfig: $(obj)/qconf
23	$< $(silent) $(Kconfig)
24
25gconfig: $(obj)/gconf
26	$< $(silent) $(Kconfig)
27
28menuconfig: $(obj)/mconf
29	$< $(silent) $(Kconfig)
30
31config: $(obj)/conf
32	$< $(silent) --oldaskconfig $(Kconfig)
33
34nconfig: $(obj)/nconf
35	$< $(silent) $(Kconfig)
36
37# This has become an internal implementation detail and is now deprecated
38# for external use.
39syncconfig: $(obj)/conf
40	$(Q)mkdir -p include/config include/generated
41	$(Q)test -e include/generated/autoksyms.h || \
42	    touch   include/generated/autoksyms.h
43	$< $(silent) --$@ $(Kconfig)
44
45localyesconfig localmodconfig: $(obj)/conf
46	$(Q)mkdir -p include/config include/generated
47	$(Q)perl $(srctree)/$(src)/streamline_config.pl --$@ $(srctree) $(Kconfig) > .tmp.config
48	$(Q)if [ -f .config ]; then 					\
49			cmp -s .tmp.config .config ||			\
50			(mv -f .config .config.old.1;			\
51			 mv -f .tmp.config .config;			\
52			 $< $(silent) --oldconfig $(Kconfig);		\
53			 mv -f .config.old.1 .config.old)		\
54	else								\
55			mv -f .tmp.config .config;			\
56			$< $(silent) --oldconfig $(Kconfig);		\
57	fi
58	$(Q)rm -f .tmp.config
59
60# Create new linux.pot file
61# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
62update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
63	$(Q)$(kecho) "  GEN     config.pot"
64	$(Q)xgettext --default-domain=linux                         \
65	    --add-comments --keyword=_ --keyword=N_                 \
66	    --from-code=UTF-8                                       \
67	    --files-from=$(srctree)/scripts/kconfig/POTFILES.in     \
68	    --directory=$(srctree) --directory=$(objtree)           \
69	    --output $(obj)/config.pot
70	$(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
71	$(Q)(for i in `ls $(srctree)/arch/*/Kconfig      \
72	    $(srctree)/arch/*/um/Kconfig`;               \
73	    do                                           \
74		$(kecho) "  GEN     $$i";                    \
75		$(obj)/kxgettext $$i                     \
76		     >> $(obj)/config.pot;               \
77	    done )
78	$(Q)$(kecho) "  GEN     linux.pot"
79	$(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
80	    --output $(obj)/linux.pot
81	$(Q)rm -f $(obj)/config.pot
82
83# These targets map 1:1 to the commandline options of 'conf'
84simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
85	alldefconfig randconfig listnewconfig olddefconfig
86PHONY += $(simple-targets)
87
88$(simple-targets): $(obj)/conf
89	$< $(silent) --$@ $(Kconfig)
90
91PHONY += oldnoconfig silentoldconfig savedefconfig defconfig
92
93# oldnoconfig is an alias of olddefconfig, because people already are dependent
94# on its behavior (sets new symbols to their default value but not 'n') with the
95# counter-intuitive name.
96oldnoconfig: olddefconfig
97	@echo "  WARNING: \"oldnoconfig\" target will be removed after Linux 4.19"
98	@echo "            Please use \"olddefconfig\" instead, which is an alias."
99
100# We do not expect manual invokcation of "silentoldcofig" (or "syncconfig").
101silentoldconfig: syncconfig
102	@echo "  WARNING: \"silentoldconfig\" has been renamed to \"syncconfig\""
103	@echo "            and is now an internal implementation detail."
104	@echo "            What you want is probably \"oldconfig\"."
105	@echo "            \"silentoldconfig\" will be removed after Linux 4.19"
106
107savedefconfig: $(obj)/conf
108	$< $(silent) --$@=defconfig $(Kconfig)
109
110defconfig: $(obj)/conf
111ifeq ($(KBUILD_DEFCONFIG),)
112	$< $(silent) --defconfig $(Kconfig)
113else
114ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG)),)
115	@$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
116	$(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
117else
118	@$(kecho) "*** Default configuration is based on target '$(KBUILD_DEFCONFIG)'"
119	$(Q)$(MAKE) -f $(srctree)/Makefile $(KBUILD_DEFCONFIG)
120endif
121endif
122
123%_defconfig: $(obj)/conf
124	$(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
125
126configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
127
128%.config: $(obj)/conf
129	$(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
130	$(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
131	+$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
132
133PHONY += kvmconfig
134kvmconfig: kvm_guest.config
135	@:
136
137PHONY += xenconfig
138xenconfig: xen.config
139	@:
140
141PHONY += tinyconfig
142tinyconfig:
143	$(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
144
145# Help text used by make help
146help:
147	@echo  '  config	  - Update current config utilising a line-oriented program'
148	@echo  '  nconfig         - Update current config utilising a ncurses menu based'
149	@echo  '                    program'
150	@echo  '  menuconfig	  - Update current config utilising a menu based program'
151	@echo  '  xconfig	  - Update current config utilising a Qt based front-end'
152	@echo  '  gconfig	  - Update current config utilising a GTK+ based front-end'
153	@echo  '  oldconfig	  - Update current config utilising a provided .config as base'
154	@echo  '  localmodconfig  - Update current config disabling modules not loaded'
155	@echo  '  localyesconfig  - Update current config converting local mods to core'
156	@echo  '  defconfig	  - New config with default from ARCH supplied defconfig'
157	@echo  '  savedefconfig   - Save current config as ./defconfig (minimal config)'
158	@echo  '  allnoconfig	  - New config where all options are answered with no'
159	@echo  '  allyesconfig	  - New config where all options are accepted with yes'
160	@echo  '  allmodconfig	  - New config selecting modules when possible'
161	@echo  '  alldefconfig    - New config with all symbols set to default'
162	@echo  '  randconfig	  - New config with random answer to all options'
163	@echo  '  listnewconfig   - List new options'
164	@echo  '  olddefconfig	  - Same as oldconfig but sets new symbols to their'
165	@echo  '                    default value without prompting'
166	@echo  '  kvmconfig	  - Enable additional options for kvm guest kernel support'
167	@echo  '  xenconfig       - Enable additional options for xen dom0 and guest kernel support'
168	@echo  '  tinyconfig	  - Configure the tiniest possible kernel'
169
170# lxdialog stuff
171check-lxdialog  := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
172
173# Use recursively expanded variables so we do not call gcc unless
174# we really need to do so. (Do not call gcc as part of make mrproper)
175HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
176                    -DLOCALE
177
178# ===========================================================================
179# Shared Makefile for the various kconfig executables:
180# conf:	  Used for defconfig, oldconfig and related targets
181# nconf:  Used for the nconfig target.
182#         Utilizes ncurses
183# mconf:  Used for the menuconfig target
184#         Utilizes the lxdialog package
185# qconf:  Used for the xconfig target
186#         Based on Qt which needs to be installed to compile it
187# gconf:  Used for the gconfig target
188#         Based on GTK+ which needs to be installed to compile it
189# object files used by all kconfig flavours
190
191lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
192lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
193
194conf-objs	:= conf.o  zconf.tab.o
195mconf-objs     := mconf.o zconf.tab.o $(lxdialog)
196nconf-objs     := nconf.o zconf.tab.o nconf.gui.o
197kxgettext-objs	:= kxgettext.o zconf.tab.o
198qconf-cxxobjs	:= qconf.o
199qconf-objs	:= zconf.tab.o
200gconf-objs	:= gconf.o zconf.tab.o
201
202hostprogs-y := conf nconf mconf kxgettext qconf gconf
203
204targets		+= zconf.tab.c zconf.lex.c
205clean-files	:= qconf.moc .tmp_qtcheck .tmp_gtkcheck
206clean-files	+= zconf.tab.c zconf.lex.c gconf.glade.h
207clean-files     += config.pot linux.pot
208
209# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
210PHONY += $(obj)/dochecklxdialog
211$(addprefix $(obj)/, mconf.o $(lxdialog)): $(obj)/dochecklxdialog
212$(obj)/dochecklxdialog:
213	$(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
214
215always := dochecklxdialog
216
217# Add environment specific flags
218HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
219HOST_EXTRACXXFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCXX) $(HOSTCXXFLAGS))
220
221# generated files seem to need this to find local include files
222HOSTCFLAGS_zconf.lex.o	:= -I$(src)
223HOSTCFLAGS_zconf.tab.o	:= -I$(src)
224
225HOSTLOADLIBES_qconf	= $(KC_QT_LIBS)
226HOSTCXXFLAGS_qconf.o	= $(KC_QT_CFLAGS)
227
228HOSTLOADLIBES_gconf	= `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
229HOSTCFLAGS_gconf.o	= `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
230                          -Wno-missing-prototypes
231
232HOSTLOADLIBES_mconf   = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
233
234HOSTLOADLIBES_nconf	= $(shell \
235				pkg-config --libs menuw panelw ncursesw 2>/dev/null \
236				|| pkg-config --libs menu panel ncurses 2>/dev/null \
237				|| echo "-lmenu -lpanel -lncurses"  )
238$(obj)/qconf.o: $(obj)/.tmp_qtcheck
239
240ifeq ($(MAKECMDGOALS),xconfig)
241$(obj)/.tmp_qtcheck: $(src)/Makefile
242-include $(obj)/.tmp_qtcheck
243
244# Qt needs some extra effort...
245$(obj)/.tmp_qtcheck:
246	@set -e; $(kecho) "  CHECK   qt"; \
247	if pkg-config --exists Qt5Core; then \
248	    cflags="-std=c++11 -fPIC `pkg-config --cflags Qt5Core Qt5Gui Qt5Widgets`"; \
249	    libs=`pkg-config --libs Qt5Core Qt5Gui Qt5Widgets`; \
250	    moc=`pkg-config --variable=host_bins Qt5Core`/moc; \
251	elif pkg-config --exists QtCore; then \
252	    cflags=`pkg-config --cflags QtCore QtGui`; \
253	    libs=`pkg-config --libs QtCore QtGui`; \
254	    moc=`pkg-config --variable=moc_location QtCore`; \
255	else \
256	    echo >&2 "*"; \
257	    echo >&2 "* Could not find Qt via pkg-config."; \
258	    echo >&2 "* Please install either Qt 4.8 or 5.x. and make sure it's in PKG_CONFIG_PATH"; \
259	    echo >&2 "*"; \
260	    exit 1; \
261	fi; \
262	echo "KC_QT_CFLAGS=$$cflags" > $@; \
263	echo "KC_QT_LIBS=$$libs" >> $@; \
264	echo "KC_QT_MOC=$$moc" >> $@
265endif
266
267$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
268
269ifeq ($(MAKECMDGOALS),gconfig)
270-include $(obj)/.tmp_gtkcheck
271
272# GTK+ needs some extra effort, too...
273$(obj)/.tmp_gtkcheck:
274	@if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then		\
275		if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then			\
276			touch $@;								\
277		else									\
278			echo >&2 "*"; 							\
279			echo >&2 "* GTK+ is present but version >= 2.0.0 is required.";	\
280			echo >&2 "*";							\
281			false;								\
282		fi									\
283	else										\
284		echo >&2 "*"; 								\
285		echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; 	\
286		echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; 	\
287		echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; 		\
288		echo >&2 "*"; 								\
289		false;									\
290	fi
291endif
292
293$(obj)/zconf.tab.o: $(obj)/zconf.lex.c
294
295$(obj)/qconf.o: $(obj)/qconf.moc
296
297quiet_cmd_moc = MOC     $@
298      cmd_moc = $(KC_QT_MOC) -i $< -o $@
299
300$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
301	$(call cmd,moc)
302
303# Extract gconf menu items for i18n support
304$(obj)/gconf.glade.h: $(obj)/gconf.glade
305	$(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
306	$(obj)/gconf.glade
307